<?php
require_once("core/main.php");
require_once("modules/divx/functions.php");
require_once("core/parser.php");

if( !check_module("divx") ) die( "module not enabled" );
$index_page = false;

if( isset($_GET["edit"]) ) $page_name = $lang["DIVX_EDIT_TITLE"];
else if( isset($_GET["new"]) ) $page_name = $lang["DIVX_SUBMIT_TITLE"];
else if( !isset($_POST["form_submit"]) ) $page_name = $lang["DIVX_PENDING_TITLE"];
else $page_name = $lang["DIVX_SUBMIT_TITLE"];

draw_header();
if( !$_SESSION["wt"]["logged"] )
{
    theme_draw_centerbox_open( $lang["DIVX_SUBMIT_TITLE"] );
	print "<span class=\"error\">{$lang["NOT_LOGGED_DIVX"]}</span>";
	theme_draw_centerbox_close();
    draw_footer();
    exit;
}

$error = "";
$rec_sent = false;

if( isset($_GET["edit"]) )
{
    $edit = intval($_GET["edit"]);
    $stmt = "select * from {$config["prefix"]}_divx where cod=$edit";
    $ret = db_query( $stmt );
    if(!$ret) $error .= $lang["ERROR_04"]."<br>".db_error();
    else
    {
        $divx = db_fetch_array( $ret );
        db_free_result($ret);
        if( !$divx ) $error .= "Invalid code<br>";
        else
        {
            if( !check_user_class("admin") )
            {
                // checks if the user owns this DIVX
                if( $divx["userid"] != $_SESSION["wt"]["uid"] ) $error .= "This DIVX isn't yours";
            }
        }
    }
    if( strlen($error) == 0 )
    {
        $divx_cod = $divx["cod"];
        $divx_date = show_date($divx["date"]);
        $divx_userid = $divx["userid"];
        $divx_title = $divx["title"];
        $divx_image = $divx["image"];
        $divx_align = $divx["align"];
        $divx_vcodec = $divx["vcodec"];
        $divx_vbitrate = $divx["vbitrate"];
        $divx_vheight = $divx["vheight"];
        $divx_vwidth = $divx["vwidth"];
        $divx_acodec = $divx["acodec"];
        $divx_abitrate = $divx["abitrate"];
        $divx_achannels = $divx["achannels"];
        $divx_asamples = $divx["asamples"];
        $divx_duration = $divx["duration"];
        $divx_size = $divx["size"];
        $divx_rate = $divx["rate"];
        $divx_lang = $divx["lang"];
        $divx_sub = $divx["sub"];
        $divx_cat = $divx["category"];
        $divx_text = $divx["text"];
        $divx_text_ori = $divx["text_ori"];
        $divx_full_text = $divx["full_text"];
        $divx_full_text_ori = $divx["full_text_ori"];
        $divx_active = $divx["active"];
        $divx_archived = $divx["archived"];
        $divx_action = "edit";
    }
}
else if( isset($_GET["new"]) )
{
    $divx_cod = 0;
    $divx_date = show_date( date("Y-m-d H:i:s"), true );
    $divx_userid = $_SESSION["wt"]["uid"];
    $divx_title = "";
    $divx_image = "none";
    $divx_align = "left";
    $divx_vcodec = "";
    $divx_vbitrate = 0;
    $divx_vheight = 0;
    $divx_vwidth = 0;
    $divx_acodec = "";
    $divx_abitrate = 0;
    $divx_achannels = 0;
    $divx_asamples = 0;
    $divx_duration = "00:00:00";
    $divx_size = 0;
    $divx_lang = "";
    $divx_sub = "";
    $divx_rate = 0;
    $divx_cat = 1;
    $divx_text = "";
    $divx_text_ori = "";
    $divx_full_text = "";
    $divx_full_text_ori = "";
    $divximgupload = "";
    $divx_active = check_user_class("divx")?"Y":"N";
    $divx_archived = "N";
    $divx_action = "new";
}
if( isset($_POST["form_submit"]) )
{
	// mirar si se borra
	if( isset($_POST["delete_divx"]) )
	{
		if( !check_user_class("divx") ) {
			theme_draw_centerbox_open( $lang["DIVX_SUBMIT_TITLE"] );
			print "<div class=\"error\">{$lang["ERROR_11"]}</div>";
			theme_draw_centerbox_close();
			draw_footer();
			exit;
		}
		$divx_cod = intval($_POST["divx_cod"]);
		$stmt = "DELETE FROM {$config["prefix"]}_divx WHERE cod='$divx_cod'";
        $ret = db_query( $stmt );
	if(!$ret)
            {
        	echo $lang["ERROR_04"]."<br>".db_error();
              draw_footer();
              exit;
		} else {
			theme_draw_centerbox_open( $lang["DIVX_EDIT_TITLE"] );
			print $lang["DIVX_DELETED"];
			theme_draw_centerbox_close();
			draw_footer();
			exit;
		}
	}
    // usurio envio DIVX
    $error = "";
    $divx_cod = intval($_POST["divx_cod"]);
    if( isset($_POST["divx_userid"]) ) $divx_userid = intval($_POST["divx_userid"]);
    else $divx_userid = $_SESSION["wt"]["uid"];
    $divx_date = trim(strip_tags($_POST["divx_date"]));
    $divx_title = trim(strip_tags($_POST["divx_title"]));
    $divx_image = trim(strip_tags($_POST["divx_image"]));
    $divx_align = trim(strip_tags($_POST["divx_align"]));
    $divx_vcodec = trim(strip_tags($_POST["divx_vcodec"]));
    $divx_vbitrate = intval($_POST["divx_vbitrate"]);
    $divx_vheight = intval($_POST["divx_vheight"]);
    $divx_vwidth = intval($_POST["divx_vwidth"]);
    $divx_acodec = trim(strip_tags($_POST["divx_acodec"]));
    $divx_abitrate = intval($_POST["divx_abitrate"]);
    $divx_achannels = intval($_POST["divx_achannels"]);
    $divx_asamples = intval($_POST["divx_asamples"]);
    $divx_duration = trim(strip_tags($_POST["divx_duration"]));
    $divx_size = intval($_POST["divx_size"]);
    $divx_rate = intval($_POST["divx_rate"]);
    $divx_lang = trim(strip_tags($_POST["divx_lang"]));
    $divx_sub = trim(strip_tags($_POST["divx_sub"]));
    $divx_cat = intval($_POST["divx_cat"]);
    $divx_text = trim($_POST["divx_text"]);
    $divx_text_ori = trim($_POST["divx_text_ori"]);
    $divx_full_text = trim($_POST["divx_full_text"]);
    $divx_full_text_ori = trim($_POST["divx_full_text_ori"]);

    if( isset($_POST["divx_active"]) ) $divx_active = ($_POST["divx_active"]=="Y")?"Y":"N";
    else $divx_active = "N";
    if( isset($_POST["divx_archived"]) ) $divx_archived = ($_POST["divx_archived"]=="Y")?"Y":"N";
    else $divx_archived = "N";
    $divx_action = trim(strip_tags($_POST["divx_action"]));
    // if the user isn't the admin or DIVX access
    if( !check_user_class("divx") )
    {
        $divx_userid = $_SESSION["wt"]["uid"];
        $divx_date = show_date( date("Y-m-d H:i:s"), true );
        $divx_active = "N";
        $divx_archived = "N";
    }
    if( $divx_action != "new" && $divx_action != "edit" ) $error .= "Invalid action<br>";
    if( strlen($divx_title) <= 0 ) $error .= $lang["ERROR_02"];
    if( strlen($divx_text) <= 0 ) $error .= $lang["ERROR_03"];
    if( strlen($divx_full_text) <= 0 ) $error .= $lang["ERROR_03"];
    if( $divx_cat <= 0 ) $divx_cat = 1;
	if( $error == "" ) {
		// parse the texts
		$err = "";
		$divx_text_parsed = $divx_text;
		parse_tags3( $divx_text_parsed, $err );
		if( strlen($err) > 0 ) $error .= "Text: ".$lang["ERROR_10"]." - $err<br>";

		// if( strlen($divx_full_text) > 0 ) {
			// parse the texts
		//	$err = "";
			$divx_full_text_parsed = $divx_full_text;
		//	parse_tags3( $divx_full_text_parsed, $err );
		//	if( strlen($err) > 0 ) $error .= "Full Text: ".$lang["ERROR_10"]." - $err<br>";
		//} else $divx_full_text_parsed = "";
	}
    if( $error == "" )
    {
        if( $divx_action == "new" )
        {
               if( $divximgupload != "" ) { 
	   if (upload_divx_img( $divximgupload,$divximgupload_name,$divximgupload_size,$divximgupload_type )) {
	 	$divx_image = $divximgupload_name;
	   } else {
		$divx_image = "none";
	   }
	   unlink($divximgupload); 
	 }

             $stmt = "INSERT into {$config["prefix"]}_divx ( date, title, userid, image, align, vcodec, vbitrate, vheight, vwidth, acodec, abitrate, achannels, asamples, duration, size, rate, lang, sub, active, text, text_ori, full_text, full_text_ori, category, archived ) values ( ";
            $stmt .= sprintf( "'%s','%s',%d,'%s','%s','%s',%d,%d,%d,'%s',%d,%d,%d,'%s',%d,'%s','%s','%s','%s','%s','%s','%s','%s',%d,'%s' )",
                addslashes(delmagic(conv_date($divx_date))),
                addslashes(delmagic($divx_title)),
                $divx_userid,
                addslashes(delmagic($divx_image)),
                addslashes(delmagic($divx_align)),
    	  addslashes(delmagic($divx_vcodec)),
    	  $divx_vbitrate,
    	  $divx_vheight,
    	  $divx_vwidth,
    	  addslashes(delmagic($divx_acodec)),
    	  $divx_abitrate,
   	  $divx_achannels,
    	  $divx_asamples,
    	  addslashes(delmagic($divx_duration)),
    	  $divx_size,
   	  $divx_rate,
                addslashes(delmagic($divx_lang)),
                addslashes(delmagic($divx_sub)),
                $divx_active,
                addslashes(delmagic($divx_text)),
                addslashes(delmagic($divx_text_ori)),
                addslashes(delmagic($divx_full_text_parsed)),
                addslashes(delmagic($divx_full_text_ori)),
                $divx_cat,
                $divx_archived );
	 // echo $stmt;
        } else {
            // check again if the user owns this DIVX, if he isn't admin
            $stmt = "select userid from {$config["prefix"]}_divx where cod=$divx_cod";
            $ret = db_query( $stmt );
            if(!$ret)
            {
                echo $lang["ERROR_04"]."<br>".db_error();
                draw_footer();
                exit;
            }
            $divx_userid = db_result( $ret, 0, 0 );  //$divx_cod
            db_free_result($ret);
            if( !check_user_class("admin") )
            {
                // checks if the user owns this DIVX
                if( $divx_userid != $_SESSION["wt"]["uid"] )  // $divx_cod
                {
                    echo $lang["DIVX_OWN"];
                    draw_footer();
                    exit;
                }
            }
               if( $divximgupload != "" ) { 
	   if (upload_divx_img( $divximgupload,$divximgupload_name,$divximgupload_size,$divximgupload_type )) {
	 	$divx_image = $divximgupload_name;
	   } else {
		$divx_image = "none";
	   }
	   unlink($divximgupload); 
	 }
            $stmt = sprintf( "UPDATE {$config["prefix"]}_divx set date='%s', title='%s', userid=%d, image='%s', align='%s', vcodec='%s', vbitrate='%s', vheight=%d, vwidth=%d, acodec='%s', abitrate=%d, achannels=%d, asamples=%d, duration='%s', size=%d, rate=%d, lang='%s', sub='%s', active='%s', text='%s', text_ori='%s', full_text='%s', full_text_ori='%s', category=%d, archived='%s' where cod=$divx_cod",
                addslashes(delmagic(conv_date($divx_date))),
                addslashes(delmagic($divx_title)),
                $divx_userid,
                addslashes(delmagic($divx_image)),
                addslashes(delmagic($divx_align)),
    	  addslashes(delmagic($divx_vcodec)),
    	  $divx_vbitrate,
    	  $divx_vheight,
    	  $divx_vwidth,
    	  addslashes(delmagic($divx_acodec)),
    	  $divx_abitrate,
   	  $divx_achannels,
    	  $divx_asamples,
    	  addslashes(delmagic($divx_duration)),
    	  $divx_size,
   	  $divx_rate,
                addslashes(delmagic($divx_lang)),
                addslashes(delmagic($divx_sub)),
                $divx_active,
                addslashes(delmagic($divx_text_parsed)),
                addslashes(delmagic($divx_text_ori)),
                addslashes(delmagic($divx_full_text_parsed)),
                addslashes(delmagic($divx_full_text_ori)),
                $divx_cat,
                $divx_archived );
        }
        $ret = db_query($stmt);
        if(!$ret) $error .= $lang["ERROR_04"]."<br>".db_error();

    }

    if( $error == "" )
    {
        theme_draw_centerbox_open($lang["DIVX_SUBMIT_DONE"]);
        if( !check_user_class("divx") )
        {
            echo $lang["DIVX_SUBMIT_THANKS2"];
            mail($cfg["core"]["mail_admin"], $lang["DIVX_SUBMIT_THANKS_MAIL_TITLE"], $lang["DIVX_SUBMIT_THANKS2_MAIL"],"From: ".$cfg["core"]["mail_admin"]."\n");
        } else echo $lang["DIVX_SUBMIT_DONE"];

        if( $divximgupload != "none" ) {  
        	if ( $divx_image !="none" ) {
        	 echo "<br>".$lang["DIVX_UPLOAD_DONE"].$divximgupload_name."(".$divx_image.")";
      	  } else {
         	echo "<br>".$lang["DIVX_UPLOAD_NONE"].$divximgupload."(".$divximgupload_name.")";   
     	 }
        }
        $rec_sent = true;
        // todo: must check if is a new DIVX....
        // db_query( "update {$config["prefix"]}_users set divxposted=divxposted+1 where uid='$divx_userid'" );
        theme_draw_centerbox_close();
    }
}
$list = !(isset($_GET["new"]) || isset($_GET["edit"]) || isset($_POST["form_submit"]));

if( !$rec_sent && (strlen($error) == 0) && !$list )
{
    theme_draw_centerbox_open( $lang["DIVX_SUBMIT_TITLE"] );
    include( "modules/divx/divxform.php" );
    theme_draw_centerbox_close();
}

if( $list && check_user_class("admin") )
{
    // list DIVX that are waiting for publsh
    $stmt = "select cod, date, title from {$config["prefix"]}_divx where active='N' and archived='N' order by date";
    $ret = db_query( $stmt );
    if( !$ret ) $error .= $lang["ERROR_04"]."<br>".db_error();
    else {
        if( db_num_rows($ret) > 0 )
        {
            draw_ldivx_header();
            $item = 0;
            while( $row = db_fetch_array( $ret ) )
            {
                draw_ldivx_item( $row, $item++ );
            }
            draw_ldivx_footer();
        } else {
			theme_draw_centerbox_open( $lang["DIVX_PENDING"] );
			print $lang["DIVX_PENDING_NONE"];
			theme_draw_centerbox_close();
		}
        db_free_result( $ret );
    }
}

if( strlen($error)>0 )
{
    theme_draw_centerbox_open($lang["ERROR_TITLE"]);
    echo "<span class=\"error\">$error</span>";
    theme_draw_centerbox_close();
}

draw_footer();
?>